#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two31004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 3100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two31004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two31004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 3100
# -------------------------------------------------------------------------------------------------
shot2two31004xi = {
        1:'1049x-1426y-2544z',
        2:'1057x-2900y-281z',
        3:'109x-3096y-96z',
        4:'1106x-1349y-2562z',
        5:'1157x-1271y-2579z',
        6:'118x-2035y-2334z',
        7:'11x-2062y-2314z',
        8:'1204x-1190y-2596z',
        9:'1206x-2838y-312z',
        10:'123x-1313y-2805z',
        11:'1245x-1108y-2613z',
        12:'124x-1645y-2624z',
        13:'1281x-1025y-2629z',
        14:'1312x-941y-2646z',
        15:'1313x-61y-2807z',
        16:'1336x-132y-2794z',
        17:'1337x-857y-2662z',
        18:'1352x-2768y-343z',
        19:'1355x-206y-2780z',
        20:'1357x-773y-2677z',
        21:'1369x-282y-2766z',
        22:'1371x-688y-2693z',
        23:'1379x-361y-2752z',
        24:'1381x-605y-2708z',
        25:'1384x-441y-2738z',
        26:'1385x-522y-2723z',
        27:'1493x-2690y-374z',
        28:'1596x-2657y-29z',
        29:'1630x-2605y-405z',
        30:'1733x-2569y-60z',
        31:'1761x-2513y-435z',
        32:'1864x-2474y-91z',
        33:'1888x-2414y-466z',
        34:'188x-1277y-2818z',
        35:'1991x-2372y-122z',
        36:'2008x-2308y-497z',
        37:'207x-1610y-2640z',
        38:'2111x-2264y-153z',
        39:'2123x-2196y-527z',
        40:'2226x-2149y-183z',
        41:'222x-2003y-2354z',
        42:'2231x-2078y-558z',
        43:'2332x-1955y-588z',
        44:'2333x-2028y-214z',
        45:'2426x-1826y-619z',
        46:'2435x-1902y-245z',
        47:'249x-1238y-2830z',
        48:'2513x-1693y-649z',
        49:'2529x-1770y-276z',
        50:'2593x-1556y-679z',
        51:'2615x-1634y-307z',
        52:'2665x-1415y-709z',
        53:'2695x-1493y-338z',
        54:'271x-3085y-127z',
        55:'2728x-1270y-740z',
        56:'2766x-1349y-369z',
        57:'2784x-1123y-770z',
        58:'2829x-1201y-399z',
        59:'2832x-973y-800z',
        60:'286x-1571y-2656z',
        61:'2871x-821y-829z',
        62:'2884x-1049y-430z',
        63:'2902x-668y-859z',
        64:'2924x-514y-889z',
        65:'2931x-896y-461z',
        66:'2938x-359y-919z',
        67:'2941x-49y-978z',
        68:'2944x-204y-948z',
        69:'2969x-740y-491z',
        70:'2994x-802y-8z',
        71:'2999x-583y-522z',
        72:'3020x-424y-553z',
        73:'3032x-265y-583z',
        74:'3032x-644y-39z',
        75:'3036x-106y-613z',
        76:'3061x-484y-70z',
        77:'306x-1196y-2843z',
        78:'3081x-323y-101z',
        79:'3092x-162y-132z',
        80:'322x-1965y-2375z',
        81:'362x-1528y-2672z',
        82:'372x-1188y-2947z',
        83:'39x-1676y-2607z',
        84:'420x-1923y-2394z',
        85:'432x-3065y-158z',
        86:'434x-1481y-2688z',
        87:'502x-1431y-2703z',
        88:'514x-1875y-2414z',
        89:'55x-1346y-2791z',
        90:'566x-1378y-2718z',
        91:'592x-3037y-189z',
        92:'603x-1822y-2433z',
        93:'626x-1322y-2733z',
        94:'681x-1263y-2747z',
        95:'689x-1765y-2452z',
        96:'732x-1202y-2761z',
        97:'749x-2999y-220z',
        98:'770x-1704y-2471z',
        99:'778x-1139y-2775z',
        100:'820x-1075y-2789z',
        101:'847x-1640y-2490z',
        102:'857x-1009y-2802z',
        103:'860x-24y-2978z',
        104:'887x-72y-2969z',
        105:'889x-942y-2815z',
        106:'904x-2954y-250z',
        107:'912x-122y-2960z',
        108:'917x-875y-2828z',
        109:'919x-1572y-2508z',
        110:'933x-175y-2950z',
        111:'940x-807y-2841z',
        112:'951x-231y-2941z',
        113:'958x-740y-2853z',
        114:'966x-289y-2931z',
        115:'972x-672y-2865z',
        116:'977x-349y-2921z',
        117:'982x-605y-2877z',
        118:'984x-411y-2910z',
        119:'986x-1500y-2526z',
        120:'987x-539y-2888z',
        121:'988x-474y-2899z'}
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3100two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3100two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3100TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3100TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3100TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3100TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3100TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two31004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3100TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3100TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3100TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two31004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two31004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3100TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3100TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3100TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two31004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        
        